<?php
/*************************************************************************/
/* Smart Extranet  2004-2010. All right reserved.www.smart-extranet.com */
/*************************************************************************/


//ini_set('error_reporting', E_ALL);
ini_set('error_reporting', E_COMPILE_ERROR|E_ERROR|E_CORE_ERROR);



include("_config/config.inc.php");
include("_config/obconfig.inc.php");
include("_include/connect.inc.php");
include("_lang/" . $LANGUAGE_ID . "/" . "labels.inc.php");
include("_include/functions.inc.php");



	function globr($sDir, $sPattern, $nFlags = NULL)
	{
	  $sDir = escapeshellcmd($sDir);

	  // Get the list of all matching files currently in the
	  // directory.

	  $aFiles = glob("$sDir/$sPattern", $nFlags);

	  // Then get a list of all directories in this directory, and
	  // run ourselves on the resulting array.  This is the
	  // recursion step, which will not execute if there are no
	  // directories.

	  foreach (glob("$sDir/*", GLOB_ONLYDIR) as $sSubDir)
	  {
	    $aSubFiles = globr($sSubDir, $sPattern, $nFlags);
	    $aFiles = array_merge($aFiles, $aSubFiles);
	  }

	  // The array we return contains the files we found, and the
	  // files all of our children found.

	  return $aFiles;
	} 

	function rapport_files()
	{
		$header = "<table style=\"width:100%;margin-bottom:10px;font-size:11px;font-family:courrier;\">";
		$footer = "</table>";
		$line = "<body  style=\"font-family:courrier;\">";
		
		#header
		$line .= date("d/m/Y H:i")."<br />";
		$line .= $GLOBALS['SITE_ROOT']."<br />";
		$line .= $GLOBALS['DB_NAME']." - ".$GLOBALS['DB_HOST']."<br />"."<br />";
		
		$D_S = $GLOBALS['D_S'];
		if($GLOBALS['BEFORE_WWW'] == true)
		{
			$total = (dir_space(goto_www()) + dir_space($GLOBALS['WWW_SECURITY'].'incoming') + dir_space($GLOBALS['WWW_SECURITY'].'storage'))/1024;
		}
		else
		{
			$total = dir_space(goto_www())/1024;
		}
		$space_used = number_format($total / 1024, 2, '.', ' ');
		$space_total = number_format($D_S / 1024,2, '.', ' ');
		$space_pct = number_format($total*100/$D_S, 2, '.', ' ');
		$spaces = dlookup("count(*)","smart_extranet","");
		$users = dlookup("count(*)","smart_user","");
		$documents = dlookup("count(*)","smart_document","is_directory = '0'");
		$next_ai = dlookup("max(id)","smart_document","") + 1;
		$comments = dlookup("count(*)","smart_comment","");

		$line .= "Space disk used : ".$space_used."Mb / ".$space_total."Mb (".$space_pct."%)"."<br />";
		$line .= $spaces." spaces"."<br />";
		$line .= $users." users"."<br />";
		$line .= $documents." documents (next id document record = ".$next_ai.")"."<br />";
		$line .= $comments." comments"."<br />";
		
		
		#last 10 files
		
		$nb = dlookup("count(*)","smart_document","type = 'file' AND is_directory = '0'");
		
		$line .= "<b>==========> Overview on last 10 files (total = ".$nb.")</b>\n";
		$line .= $header;
		
		
		$sql = "SELECT smart_document.id, publish_time, smart_document.name, file_type, file_size, uploaded_by, smart_extranet.name as ext_name,smart_extranet.id as ext_id FROM smart_document INNER JOIN smart_extranet ON smart_document.extranet_id = smart_extranet.id AND is_directory = '0' WHERE type = 'file' ORDER BY publish_time DESC LIMIT 0,10";
		
		$results_request = mysql_query($sql);
		while ($row_request = mysql_fetch_array($results_request))
		{
			$line .= "<tr>";
			$line .= "<td style=\"width:3%\">".$row_request['id']."</td>";
			$line .= "<td style=\"width:25%\">".$row_request['publish_time']."</td>";
			$line .= "<td style=\"width:25%\">".$row_request['name'].".".$row_request['file_type']."</td>";
			$line .= "<td style=\"width:7%\">".$row_request['file_size']." Kb</td>";
			$line .= "<td style=\"width:20%\">".$row_request['uploaded_by']."</td>";
			$line .= "<td style=\"width:20%\">".$row_request['ext_name']." (".$row_request['ext_id'].")</td>";
			$line .= "</tr>";
		}
		
		$line .= $footer;
		
		#files in db but not in the storage disk
		
		
		
		$sql = "SELECT smart_document.id, publish_time, smart_document.name, file_type, file_size, uploaded_by, smart_extranet.name as ext_name,smart_extranet.id as ext_id FROM smart_document INNER JOIN smart_extranet ON smart_document.extranet_id = smart_extranet.id WHERE type = 'file' AND is_directory = '0' ORDER BY publish_time";
		$lineb = ""; 
		$i = 0;
		$pds = 0;
		$img = 0;
		$results_request = mysql_query($sql);
		while ($row_request = mysql_fetch_array($results_request))
		{
			if (!is_file($GLOBALS['WWW_SECURITY']."storage/".$row_request['ext_id']."/".$row_request['id']))
			{
				if ( $row_request['file_type'] == 'jpg' OR $row_request['file_type'] == 'gif' OR $row_request['file_type'] == 'png')
				{
					$img++;
				}
				$lineb .= "<tr>";
				$lineb .= "<td style=\"width:3%\">".$row_request['id']."</td>";
				$lineb .= "<td style=\"width:25%\">".$row_request['publish_time']."</td>";
				$lineb .= "<td style=\"width:25%\">".$row_request['name'].".".$row_request['file_type']."</td>";
				$lineb .= "<td style=\"width:7%\">".$row_request['file_size']." Kb</td>";
				$lineb .= "<td style=\"width:20%\">".$row_request['uploaded_by']."</td>";
				$lineb .= "<td style=\"width:20%\">".$row_request['ext_name']." (".$row_request['ext_id'].")</td>";
				$lineb .= "</tr>";
				$i++;
				$pds = $pds + $row_request['file_size'];
			}
		}
		
		$line .= "<b>==========> ".$i." file(s) missing in application (".$pds." Kb)</b>\n";
		$line .= $header;
		$line .= $lineb;
		$line .= $footer;
		if ($img > 0) 
		{
			$line .= "<p>For jpg, gif and png files format, If you want to restore previzualisation files, don't forget to add<br /> \n
			2 previzualisation files for each missing file, named as well :<br />\n
			photo_[fileID].jpg and thumb_[fileID].jpg.<br />\n
			Drop them in : storage/[extranetID]/thumbs</p>\n
";
		}
		
		
		#files in the storage disk but not in the db
		$lineb = ""; 
		$dir = $GLOBALS['WWW_SECURITY']."storage/";
		$dir_res = opendir($dir);
		$i = 0;
		$pds = 0;
		while ($content = readdir($dir_res)) 
		{
			if ($content != "." && $content != ".." && is_dir($dir.$content)) 
			{
				$dirs = $GLOBALS['WWW_SECURITY']."storage/".$content."/";
				$dirs_res = opendir($dirs);
				while ($contents = readdir($dirs_res)) 
				{
					if ($contents != "." && $contents != ".." && !is_dir($dirs.$contents)) 
					{
						$presence = dlookup("count(*)","smart_document","id=".$contents." AND is_directory = '0' AND extranet_id = ".$content);
						if ($presence == 0)
						{
							$lineb .= "<tr>";
							$lineb .= "<td style=\"width:3%\">".$contents."</td>";
							$lineb .= "<td style=\"width:25%\">storage/".$content."</td>";
							$i++;
							$pds = $pds + round(filesize($dirs.$contents)/1024);
						}
					}
				}
			}
		}
		$line .= "<b>==========> ".$i." file(s) no longer used in application (".$pds." Kb)</b>\n";
		$line .= $header;
		$line .= $lineb;
		$line .= $footer;
		if ($i > 0) 
		{
			$line .= "<p>For jpg, gif and png assets dont forget to delete 2 thumbnail files named : photo_[fileID].jpg and thumb_[fileID].jpg in : storage/[extranetID]/thumbs</p>";
		}
		
		
		#files in incoming

		
		$files = globr($GLOBALS['WWW_SECURITY']."incoming","*.*");
		$i = count($files);
		if (file_exists($GLOBALS['WWW_SECURITY']."incoming/Important.txt"))
		{
			$i = count($files) - 1;
		}
		
		$line .= "<b>==========> ".$i." file(s) waiting in incoming directory</b>\n";
		
		return $line."</body>";
		
	}

	function zip_archive2($name)
	{
		$complete = true;
		dump_db("dump_".$GLOBALS['DB_NAME']."_".date('d_m_Y_H_i').".sql");
		sleep(4); 
		$archive = new PclZip($GLOBALS['WWW_SECURITY'].'config_backup/'.$name);
		  $v_list = $archive->add($GLOBALS['WWW_SECURITY'].'db_backup/,'.goto_www().'/_assets/,'.goto_www().'/_config/config.inc.php,'.goto_www().'/_config/obconfig.inc.php,'.goto_www().'/_config/trialconfig.inc.php',PCLZIP_OPT_REMOVE_PATH, "..");
		  //$v_list = $archive->add('../www/_images/',PCLZIP_OPT_REMOVE_PATH, "..");
		  if ($v_list == 0) {
		    $complete = false;
		  }

		  
		/*$headers = "MIME-Version: 1.0\n";
		$headers .= "Content-type: text/html; charset=iso-8859-1\n";
		$headers .= "X-Priority: 3\n";
		$headers .= "X-Mailer: php\n";
		$headers .= "X-Sender: <".$GLOBALS['MAINTAIN_EMAIL'].">\n"; 
		$headers .= "From: \"".$GLOBALS['PRODUCT_NAME']."\" <".$GLOBALS['MAINTAIN_EMAIL'].">\n";
		$headers .= "Return-Path: <".$GLOBALS['MAINTAIN_EMAIL'].">\n"; 		  */
		  
		if ($complete == true)
		{
			sleep(4);  
			 
			$dir = $GLOBALS['WWW_SECURITY']."config_backup/";
			$dir_res = opendir($dir);
			$zip = array();
			$i = 0;

			$file_to_delete = "";
			$atime = "2000000000";

			while ($content = readdir($dir_res)) 
			{
					if ($content != "." && $content != ".." && !is_dir($content)) 
					{
						if(is_file($GLOBALS['WWW_SECURITY']."config_backup/".$content))
						{
							$f_time =  filemtime($GLOBALS['WWW_SECURITY']."config_backup/".$content);
							if ($f_time < $atime)
							{
								$file_to_delete = $content;
								$atime = $f_time;
							}
							$i++;
						}
					}
			}

			if($i > 1)
			{
				unlink($GLOBALS['WWW_SECURITY']."config_backup/".$file_to_delete);
			} 
			/*
			$body = date('d/m/Y H\h i\m\i\n s\s', time())."<br />";
			$body .= $GLOBALS['_0100507_back_ok'] . " ". $GLOBALS['SITE_ROOT']."<br />";
			$body .= $GLOBALS['_0100514_ok_backupmail'] ."<br />";
			$body .= $name ." : ".round(filesize("../config_backup/".$name)/1024)." ko";

			mail($GLOBALS['MAINTAIN_EMAIL'], $GLOBALS['_0100507_back_ok'] . " ". $GLOBALS['SITE_ROOT']." - ". $GLOBALS['_0100672_title_cfg_mail'], $body,$headers);
			*/
		}

		return $complete;
	}
	
	
//$file_auto_db = "backup_db.txt";
//$file_auto_config = "backup_config.txt";

$today = mktime(0, 0, 0, date('m'), date('d'), date('Y'));

#Header email
$boundary='didondinaditondelosdudosdodudundodudindon';
$headers = "MIME-Version: 1.0\n";
//$headers .= "Content-type: text/html; charset=iso-8859-1\n";
$headers .= "Content-Type: multipart/mixed; boundary=\"".$boundary."\"\n";;
$headers .= "X-Priority: 3\n";
$headers .= "X-Mailer: php\n";
$headers .= "X-Sender: <".$MAINTAIN_EMAIL.">\n"; 
$headers .= "From: \"".$PRODUCT_NAME."\" <".$MAINTAIN_EMAIL.">\n";
$headers .= "Return-Path: <".$MAINTAIN_EMAIL.">\n"; 
		

#What I'm doing ?

$do_it = $_REQUEST['doit'];
$code = $_REQUEST['code'];
$mode = $_REQUEST['mode'];

echo "<html><head><title>" . $_0100227_tech_info_tit . "</title><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\" />";
echo "</head><body>";
echo "<p>".$SITE_ROOT."</p>";
echo utf8_encode("<p>Task : ".$do_it."</p>");


#IF code is good
if($code == $MAINTENANCE_CODE && $BACK_UP_ACTIVATION == true)
{
	$make_action = false;
	switch ($do_it)
	{
		#DB --------------------------------------------------------------------------------------
		case "db":
			switch ($mode)
			{
				#Manual -----------------------------------------------------------------
				case "manual":
					$make_action = true;
					break;
				#Auto --------------------------------------------------------------------
				case "auto":
					$info = get_option("backup_db");
					#IF timestamp file < timestamp dotay (@ 0h00)
					#update file and action = ok
					if($info < $today)
					{
						$make_action = true;
						set_option("backup_db",time());
					}
					else
					{
						echo utf8_encode("<p>A report has been yet generated automatically today.</p>");
					}
					fclose($fd);
					break;
			}
			# ACTION ----------------------------------------------------------------------
			if ($make_action == true)
			{
				#Dump
				$name = "dump_".$DB_NAME."_".date('d_m_Y_H_i').".sql";
				dump_db($name);
				sleep(5);
				#Mail
				$body = "--". $boundary ."\n
Content-Type: text/html; charset=ISO-8859-1\r\n\n";
				$body .= rapport_files()."\n\n";
				
				#Attach file
				$fichier=file_get_contents($WWW_SECURITY.'db_backup/'.$name);
				$fichier=chunk_split( base64_encode($fichier));

				$body = $body . "--" .$boundary."\n";
				$body = $body . "Content-Type: application/octet-stream; name=\"".$name."\"\n";
				$body = $body . "Content-Transfer-Encoding: base64\n";
				$body = $body . "Content-Disposition: attachment; filename=\"".$name."\"\n";
				$body = $body . "\n";
				$body = $body . $fichier;
				#Send Mail
				mail($MAINTAIN_EMAIL, $SITE_ROOT." - ".date("d/m/Y H:i")." - Files review and MySQL dump", $body, $headers);
				
				echo utf8_encode("<p>Report sent to " . $MAINTAIN_EMAIL ."</p>");
				echo utf8_encode("<p>End of report</p>");
			}
			break;
			
			
		#CONFIG --------------------------------------------------------------------------------------
		case "config":
			switch ($mode)
			{
				#Manual -----------------------------------------------------------------
				case "manual":
					$make_action = true;
					break;
				#Auto --------------------------------------------------------------------
				case "auto":
					$info = get_option("backup_config");
					#IF timestamp file < timestamp dotay (@ 0h00)
					#update file and action = ok
					if($info < $today)
					{
						$make_action = true;
						set_option("backup_config",time());
					}
					else
					{
						echo "<p>A report has been yet generated automatically today.</p>";
					}
					fclose($fd);
					break;
			}	
			
			# ACTION ----------------------------------------------------------------------
			if ($make_action == true)
			{
				$name_config = str_replace("https://","",$SITE_ROOT);
				$name_config = str_replace("http://","",$name_config);
				$name_config = str_replace(".","_",$name_config);
				$name_config = str_replace("/","_",$name_config);
				$name = "config_".$name_config."_".date("d").date("m").date("Y")."_".date("H").date("i").".zip";
				include("_include/pclzip.inc.php");
				$complete = zip_archive2($name);
				if ($complete == true)
				{
					#Mail
					$body = "--". $boundary ."\n
Content-Type: text/html; charset=ISO-8859-1\r\n\n";
					$body .= rapport_files()."\n\n";
					#Attach file
					$fichier=file_get_contents($WWW_SECURITY.'config_backup/'.$name);
					$fichier=chunk_split( base64_encode($fichier));

					$body = $body . "--" .$boundary."\n";
					$body = $body . "Content-Type: multipart/x-zip; name=\"".$name."\"\n";
					$body = $body . "Content-Transfer-Encoding: base64\n";
					$body = $body . "Content-Disposition: attachment; filename=\"".$name."\"\n";
					$body = $body . "\n";
					$body = $body . $fichier;
					#Send Mail
					mail($MAINTAIN_EMAIL, $SITE_ROOT." - ".date("d/m/Y H:i")." - Files review, MySQL dump and config files", $body, $headers);
				}
				else
				{
					$body = "--". $boundary ."\n
Content-Type: text/html; charset=ISO-8859-1\r\n\n";
					$body = date('d/m/Y H\h i\m\i\n s\s', time())."<br />";
					$body .= $_0100505_bck_pb . " ". $SITE_ROOT."<br />";
					$body .= $_0100464_sn . " ". $SERIAL_NUMBER."<br />";
					$body .= $_0100506_check ."<br />";
					#Send Mail
					mail($MAINTAIN_EMAIL, $_0100505_bck_pb . " ". $SITE_ROOT, $body,$headers);
					echo utf8_encode("<p>Error</p>");
				}
				echo utf8_encode("<p>Report sent to " . $MAINTAIN_EMAIL ."</p>");
				echo utf8_encode("<p>End of report</p>");
			}
			break;
	}
}
else
{
	echo "<p>Invalid password or Backup not active</p>";
}
echo "<p><a id=\"close\" onclick=\"window.close(); return false;\" href=\"#\">".$_0100200_close_terms."</a></p>";
echo "</body></html>";
?>
