<?php
/*************************************************************************/
/* Smart Extranet  2004-2010. All right reserved.www.smart-extranet.com */
/*************************************************************************/


//ini_set('error_reporting', E_ALL);
ini_set('error_reporting', E_COMPILE_ERROR|E_ERROR|E_CORE_ERROR);

session_start();

#smarty
require '_php/smarty/libs/Smarty.class.php';

#realpath of www directory
$www_path = str_replace("\\", '/', realpath("../"));

//$xml_path = $www_path;
//$xml_dest = '../incoming/ftp_rep.xml';

#smarty settings
$smarty = new Smarty;

$smarty->compile_check = true;
$smarty->debugging = false;

$smarty->compile_dir = "_cache/";
$smarty->template_dir = "_templates/";


#init error message
$error_message = '';
$path_mobile = "";
include("_config/config.inc.php");
include("_config/obconfig.inc.php");
include("_lang/lang.inc.php");
include("_include/connect.inc.php");
include("_include/functions.inc.php");
include("_include/error.inc.php");
include("_include/extranet_data.inc.php");
include("_include/GoogleMapAPI.class.php");
//$smarty->debugging_ctrl = 'URL';

$smarty->assign('LANGUAGE_ID', $LANGUAGE_ID);
$LNK_LICENCE = link_exec_licence($TIME_MINUTE);
$smarty->assign('LNK_LICENCE', $LNK_LICENCE);
$smarty->assign('LICENCE_USE', $NB_INSTALL);
$smarty->assign('ACTIVATE_SKYPE', get_option("ACTIVATE_SKYPE"));

$img_pad = get_option("img_pad");
$back_img_pad = get_option("back_img_pad");
$back_color_pad = get_option("back_color_pad");
$superimposed_img_pad = get_option("superimposed_img_pad");
$smarty->assign('img_pad', $img_pad);
$smarty->assign('back_img_pad', $back_img_pad);
$smarty->assign('back_color_pad', $back_color_pad);
$smarty->assign('superimposed_img_pad', $superimposed_img_pad);
$smarty->assign('mob_log_link',get_option("mob_log_link"));
$smarty->assign('code_google',get_option("code_google"));

if(file_exists("_java_applet"))
{
	$smarty->assign('_applet', true);	
}
else
{
	$smarty->assign('_applet', false);		
}


#error array
$error = array();

#init navigation array(link => name)
$navigation = array("" => $_0100026_home_link);

#nav_pat the navigation path - just with directories and files
$nav_path = array();

#selected directory (left menu)
$sel_dir_id = 0;
$sel_dir_name = '';

#selected document (left menu)
$doc_id = 0;

#nb char title doc
$nb_char_title = 50;

#path
$path = "";
$parent_id = 0;
#end init

#if given path


//$smarty->assign("URL_EXTRANET",$_REQUEST["ext_name"]);
$smarty->assign("URL_EXTRANET",$ext_name_enc);
if ($_REQUEST["path"] || ($_REQUEST["ext_name"] && !$extranet_found)){
  $path = path_encode($_REQUEST["path"]);
   $smarty->assign("URL_PATH",$path);
   $smarty->assign("URL_PATH_decode",urldecode($path));
   if ($_REQUEST["ext_name"] && !$extranet_found){
   	 $path_found = parse_path($_REQUEST["ext_name"] . '/' . $_REQUEST["path"], $ext_id);
   }
   else{
  	 $path_found = parse_path($_REQUEST["path"], $ext_id);
   }
   
   if ($path_found < 0){
		$error_message = $access_error[$path_found];
   }
}

#init smarty
$SMARTY_PATH = calculate_smarty_path();

$smarty->assign('PATH', $SMARTY_PATH);
#end calculate the path for smarty

#if given file id
if (isset($_REQUEST["f_id"])){
	$doc_id = $_REQUEST["f_id"];
};

if ($doc_id > 0){
	$query_count = "SELECT COUNT(*)
					FROM smart_document
					WHERE is_directory='0' AND id=" . $doc_id;
	$result_count = mysql_query($query_count);
	list($is_document) = mysql_fetch_array($result_count);
	if ($is_document == 0){
		$error_message = $access_error[-3];
	}
}

#if access error
if ($error_message != ''){
	$smarty->assign('message', $error_message);
	$smarty->display('error.tpl');
}
#if no access error
else{
	#assign extranet id, name, title
	$smarty->assign('ext_title', $ext_title);
	$smarty->assign('ext_name', $ext_name);
	$smarty->assign('ext_name_enc', $ext_name_enc);
	$smarty->assign('ext_status', $ext_status);
	$smarty->assign('ext_id', $ext_id);
	$smarty->assign('ext_storage', test_dir($ext_id));
	$smarty->assign('ext_banner_file', $ext_banner_file);
	$smarty->assign('ext_capacity', extranet_capacity($ext_id));

	#SPACE USED

	if (($T_V == true) AND ($_SESSION["rights"]!='super_admin'))
	{
		$total = dir_space($WWW_SECURITY.'storage/' . $ext_id)/1024;
		$new_max_disck_space = $T_D_S;
	}
	else
	{
		if($BEFORE_WWW == true)
		{
			$total = (dir_space(goto_www()) + dir_space($WWW_SECURITY.'incoming') + dir_space($WWW_SECURITY.'storage') + dir_space($WWW_SECURITY.'db_backup'))/1024;
		}
		else
		{
			$total = dir_space(goto_www()) /1024;
		}
		$new_max_disck_space = $D_S;
	}

	$total = round($total * 1.1,2);// + 10000000;

	if ($total<1024){
		$disk_usage = $total . " " . $_0100136_KB;
		
		$smarty->assign('total_usage', $total);
	}
	else{
		$disk_usage = number_format($total / 1024, 2, '.', ' ');
		$disk_usage = $disk_usage . " " . $_0100078_mb;
	};
	$total_usage = floor(($new_max_disck_space/1024) - ($total/1024));

	$percent = number_format($total*100/$new_max_disck_space, 2, '.', ' ');
	$percent_round = round($total*100/$new_max_disck_space);
	$max_disk = number_format($new_max_disck_space / 1024, 2, '.', ' ');

	if ($percent_round > 100)
	{
		$percent_round = 100;
		$percent = 100;
	}

	$smarty->assign('percent', $percent);
	$smarty->assign('percent_round', $percent_round);
	$smarty->assign('disk_usage', $disk_usage);
	$smarty->assign('total_usage', $total_usage);
	$smarty->assign('max_disk', $max_disk);	
	
	#copyright
	$smarty->assign('copyright_1', $COPYRIGHT_MENTION_1);
	$smarty->assign('copyright_2', $COPYRIGHT_MENTION_2);

	#Anim flash
	$smarty->assign('ANIM_FLASH_1', $ANIM_FLASH_1);
	$smarty->assign('ANIM_FLASH_2', $ANIM_FLASH_2);
	
	#agreement
	if(isset($_POST['agree'])){
		$query="UPDATE smart_user SET conditions_acceptation_date='".zonedate('Y-m-d H:i:s',$TIME_ZONE,$DAYLIGHT_SAVING)."' WHERE email='".$_SESSION['user']."'";
		$update=mysql_query($query);
			if ($COMMON_LOGIN_PAGE && !$_REQUEST["ext_name"]) {
				$_SESSION['log_session'] = log_connexion($_SESSION['user_id'],$_SESSION['user_name'],"LOGIN_SUCCESS");
				header("Location: ".give_my_favorite_extranet($_SESSION['user_id']));
			}
			else
			{
				$_SESSION['log_session'] = log_connexion($_SESSION['user_id'],$_SESSION['user_name'],"LOGIN_SUCCESS");
			}
	}

	require("_include/auth.inc.php");
	if(!isset($_GET['ext_name']) && $AUTH == true && !$COMMON_LOGIN_PAGE)
	{
		header('Location: ' . giveurl(dlookup("name","smart_extranet","def='1'"),"index",""));
	}
	#extranet closed?
	if ($ext_status == "closed"){
		if (!($_SESSION["rights"]=='super_admin') && !($_SESSION["rights"]=='limited_admin')){
			$smarty->assign('ext_logo', $ext_logo);	
			$smarty->assign('ext_logo_file', $ext_logo_file);	
			$smarty->assign('ext_logo_bdcolor', $ext_logo_bdcolor);	
			$smarty->assign('ext_logo_bdsize', $ext_logo_bdsize);	
			$smarty->assign('ext_logo_bgcolor', $ext_logo_bgcolor);	
			$smarty->assign('ext_logo_print', $ext_logo_print);	
			$smarty->display('extranet-closed.tpl');
			die();
		};
	}

	#autentification
	if(isset($_POST['login'])){
		if($bad_details){
			$error = 'error';
			$user = $_POST["user"];
			$smarty->assign('user',$user);
			$smarty->assign('error',$error);
			$nb_error_login = log_connexion(0,$user,"LOGIN_FAILED");
			$smarty->assign('nb_error_login',$nb_error_login);
			if ($nb_error_login > 2)
			{
				$try_again_after = get_last_login_failed($user) + 1800;
				$try_again_after = date('H:i', $try_again_after);
				$current_time = date('H:i', time());
				$smarty->assign('try_again_after',$try_again_after);
				$smarty->assign('current_time',$current_time);
			}
			
		}
		else
		{
			
			if ($COMMON_LOGIN_PAGE && !$_REQUEST["ext_name"]) {
				$_SESSION['log_session'] = log_connexion($_SESSION['user_id'],$_SESSION['user_name'],"LOGIN_SUCCESS");
				header("Location: ".give_my_favorite_extranet($_SESSION['user_id']));
			}
			else
			{
				$_SESSION['log_session'] = log_connexion($_SESSION['user_id'],$_SESSION['user_name'],"LOGIN_SUCCESS");
			}
			
		}
	}

	if($AUTH==false)
	{
	/*		if ($cookie_user){
				$remember = 1;
			}
			else{
				$remember = 0;
			};
			$smarty->assign('cookie_user', $cookie_user);
			$smarty->assign('cookie_pass', $cookie_pass);
			$smarty->assign('remember', $remember);
	*/
		#set extranet title, if empty
		/*if ($ext_title == ""){
			$ext_title = "Reserved space";
		};*/
		$first = htmlspecialchars(isset($_GET["param"])?$_GET["param"]:"");
		$smarty->assign('first', $first);
		$smarty->assign('ssl', $SSL);
		#ssl infos
			$fd=fopen("_assets/ssl_info.txt","r");
			$ssl_infos ="";
			while(!feof($fd))
			{
				$ssl_infos .= fgets($fd,4096);
			}
			fclose($fd);

		#gets the URI of the script
		//$url =  $_SERVER['SCRIPT_URI'];


		#chops URI
		//$chopped = parse_url($url);
		$protocol = (($_SERVER['HTTPS'] != '') ? "https://" : "http://"); //get protocol

		if ($protocol == 'http://' AND $SSL == true)
		{
			$smarty->assign('url_https', true);	
			$destination = $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
			$smarty->assign('url_https_value', 'https://'.$destination);	
		}
			
			
		$smarty->assign('ssl_infos', $ssl_infos);
		if ((!$_REQUEST["ext_name"] || !$extranet_found) && $T_V == true)
		{
			#Before, i read service overview
			#Service Overview
			$SERVICE_OVERVIEW = "";
			$fd=fopen("_assets/service_overview.txt","r");
			while(!feof($fd))
			{
				$linie=fgets($fd,4096);
				$SERVICE_OVERVIEW .= $linie;
			}
			fclose($fd);
			if(strlen($SERVICE_OVERVIEW) > 0)
			{
				include("_config/trialconfig.inc.php");
				$smarty->assign('TRIAL_TITLE_HOME',$TRIAL_TITLE_HOME);
				$smarty->assign('SERVICE_OVERVIEW',$SERVICE_OVERVIEW);
				$smarty->assign('PRODUCT_NAME',$PRODUCT_NAME);
				if ($TRIAL_MANAGEMENT_CODE == "" OR get_option("init_flag") == "0")
				{
					$smarty->assign('label_error',$_0100140_error_pagetitle);
					$smarty->assign('message',$_0100501_instal_first);
					$smarty->display("error.tpl");
				}
				else
				{
					$smarty->display('defaut_trial_home.tpl');
				}
			}
			else
			{
				$smarty->display('defaut_trial.tpl');
			}
		}
		else
		{
			$smarty->assign('ext_logo', $ext_logo);	
			$smarty->assign('ext_logo_file', $ext_logo_file);	
			$smarty->assign('ext_logo_bdcolor', $ext_logo_bdcolor);	
			$smarty->assign('ext_logo_bdsize', $ext_logo_bdsize);	
			$smarty->assign('ext_logo_bgcolor', $ext_logo_bgcolor);	
			$smarty->assign('ext_logo_print', $ext_logo_print);	
				
			$smarty->display('login.tpl');
			if($LNK_LICENCE == false)
			{
				#Create email test____________________________________________
				$body = "Day-Time : ".date('d/m/Y H\h i\m\i\n s\s', time())."\n";
				$body .= "IP : ".get_ip()."\n";
				$body .= "Url  : http://".$_SERVER['HTTP_HOST']."/ \n";
				$body .= "Site root : ".$SITE_ROOT." \n";
				$body .= "POSTMASTER EMAIL : ".$POSTMASTER_EMAIL." \n";
				$body .= "MAINTAIN EMAIL : ". $MAINTAIN_EMAIL ."\n";
				mail("registration@smart-extranet.com","unregistered version alert", $body);
			}
		}
		
		die();
	}
	else{
	
	
	#test image
if ($_REQUEST["thumb"])
{
	if (($_SESSION["rights"] != 'simple_user') OR (($_SESSION["rights"] == 'simple_user') AND (right_for_thumb($_REQUEST["thumb"],$ext_id))))
	{
		header("Content-type: image/jpeg");
		echo file_get_contents($WWW_SECURITY."storage/".$ext_id."/thumbs/thumb_".$_REQUEST["thumb"].".jpg");
		exit;
	}
}
if ($_REQUEST["photo"])
{
	if (($_SESSION["rights"] != 'simple_user') OR (($_SESSION["rights"] == 'simple_user') AND (right_for_thumb($_REQUEST["photo"],$ext_id))) )
	{
			header("Content-type: image/jpeg");
			echo file_get_contents($WWW_SECURITY."storage/".$ext_id."/thumbs/photo_".$_REQUEST["photo"].".jpg");
			exit;
	}
}
if ($_REQUEST["flash"]) {
	if (($_SESSION["rights"] != 'simple_user') OR (($_SESSION["rights"] == 'simple_user') AND (right_for_thumb($_REQUEST["flash"],$ext_id))))
	{
			$flash = $_REQUEST["flash"];
			header('Content-type: application/x-shockwave-flash');
			$affiche_swf=readfile($WWW_SECURITY."storage/".$ext_id."/".$_REQUEST["flash"]);
			echo $affiche_swf;
			exit;
	}
}

		#if type_licence = 2 and $_REQUEST param exist,
		if($T_V && isset($_REQUEST['param']))
		{
			$id_add = dlookup("id","smart_document","is_directory='0' AND extranet_id = ".$ext_id);
			$smarty->assign("id_add",$id_add);
		}
	
		#set extranet title, if empty
		if ($ext_title == "" && $_SESSION["rights"] == 'super_admin'){
			$ext_title_banner = "Enter here extranet title";
		};

		#assign obfuscated config variables
		$smarty->assign('max_extranets', $ANIM_FLASH_4);
		$smarty->assign('max_users_extranets', $ANIM_FLASH_6);
		$smarty->assign('product_name', $PRODUCT_NAME);
		$smarty->assign('licence_description', $LICENCE_DESCRIPTION);
		$smarty->assign('update_url', $UPDATE_URL);
		$smarty->assign('serial_number', $SERIAL_NUMBER);

		#assign config variables
		$smarty->assign('ACTIVATE_PROFIL', get_option("activate_profil"));
		if(get_option("activate_profil") == 1)
			{	
				$smarty->assign('profil_list', profil_list());
			}

		#assign user right variable
		$smarty->assign('user_comments_config', $USER_COMMENTS);
		$smarty->assign('user_add_doc_config', $USER_ADD_DOC);

		#Auth MU ???
		$AUTH_MU = false;
		if ($ACTIVE_MU == true)
		{
			if (($_SESSION['rights'] == 'super_admin') || ($_SESSION['rights'] == 'limited_admin'))
			{
				$AUTH_MU = true;
			}
			else
			{
				if ($_SESSION['user_add_doc_right'] == "1")
				{
					$AUTH_MU = true;
				}
			}
		}
		$smarty->assign('AUTH_MU', $AUTH_MU);
		
		#domain name
		$smarty->assign('site_root', $SITE_ROOT);
		
		
		#trial version
		$smarty->assign('TRIAL_VERSION', $T_V);
		
		#document or directory delete
		if (isset($_REQUEST['del_doc_id'])){
			delete_file($_REQUEST['del_doc_id'],$ext_id);
			//generate_xml($DESTINATION , $FTP_PREFIX);
		}
		else if (isset($_REQUEST['del_dir_id'])){
			delete_directory($_REQUEST['del_dir_id'], $ext_name);
			//generate_xml($DESTINATION , $FTP_PREFIX);
			//make_dir_tree($ext_name, $ext_id);
		};	
		include("_include/first_level_dirs.inc.php");

		#start init

		#user name
		$user_name = utf8_decode($row_user["first_name"] . ' ' . $row_user["last_name"]);
		#add title if exist
		if (strlen($row_user["title"]) > 0){
			$user_name = utf8_decode($row_user["title"] . ' ') . $user_name;
		}
		#edit documents
		include("_php/edit_documents.php");

		#refresh is needed or not? init number of incoming files
		$incoming_files = 0;
		maj_bdd_via_ftp($ext_id, $ext_name,0,0);
		
		#if asked for refresh
		//if (!$T_V)
		//{
			refresh_needed($ext_id, $ext_name);
		 	if ($incoming_files > 0){
				refresh($ext_id, $ext_name);
				$doc_id = 0;
				$parent_id = 0;
				$nav_path = array();
				$sel_dir_id = 0;
				$incoming_files = 0;
			}
			
		//}



		#if user rights = simple user, test if document is direction_only
		if (($_SESSION["rights"] == 'simple_user') && ($doc_id > 0)){
			$result_direction = mysql_query("SELECT direction_only FROM smart_document LEFT JOIN smart_document_profil ON smart_document.id = smart_document_profil.doc_id
									WHERE (direction_only='0' OR (direction_only='1' AND profil_id = ".$_SESSION['profil'].")) AND id=" . $doc_id);
			if (mysql_num_rows($result_direction) == 0){
				$doc_id=0;
			}
		}

		#assign parent directory id
		$smarty->assign('parent_id', $parent_id);

		#assign path
		$smarty->assign('php_path', $path);

		#selected dir
		$smarty->assign('sel_dir_id', $sel_dir_id);

		#user id
		$smarty->assign('user_id',$_SESSION["user_id"]);

		#user rights
		$smarty->assign('rights', $_SESSION["rights"]);

		#Active MU
		$smarty->assign('ACTIVE_MU', $ACTIVE_MU);		
		
		#Max execution time
		$smarty->assign('MAX_EXECUTION_TIME', ini_get('max_execution_time'));
		
		#user comments & add doc rights
		$smarty->assign('user_comments_right',$_SESSION["user_comments_right"]);
		$smarty->assign('user_add_doc_right',$_SESSION["user_add_doc_right"]);

		#MAX_DISK_SPACE
		$smarty->assign('MAX_SIZE_UPLOAD', $MAX_SIZE_UPLOAD);	

		#MAX_USERS_EXTRANETS
		$smarty->assign('MAX_USERS_EXTRANETS', $ANIM_FLASH_6);	
		#all directory paths
		$smarty->assign('results_paths', $results_paths);		
		#-----------------------
		#start display templates
		$smarty->display('header.tpl');

		#extranet tabs
		include("_php/extranets.php");	

		#right settings menu
		include("_php/settings_menu.php");

		#banner, company name, Extranet title
		include("_php/banner.php");

		#navigation path
		$smarty->assign('ext_def', $ext_def);
		$smarty->assign('nb_extranet_open', dlookup("count(*)","smart_extranet","status = 'open'"));
		$smarty->assign('name', $user_name);
		include("_php/navigation_path.php");



		#first level directories - in first_level_dirs.inc.php
		$smarty->assign('results_dirs', $results_dirs);

		#number of files for a Top of page
		$nb_files_for_top = 9;
		$smarty->assign('nb_files_for_top', $nb_files_for_top);
	
		#number of comment for a Top of page
		$nb_comment_for_top = 4;
		$smarty->assign('nb_comment_for_top', $nb_comment_for_top);
	
		#search page
		if (isset($_REQUEST["search_submit"])){
			$parent_dir = $SITE_ROOT . $ext_name_enc . '/' . $path;

			#last in navigation_path is the selected directory
			$smarty->assign('selected_dir', $last);
			$smarty->assign('parent_dir', $parent_dir);

			#page content
			if ($_REQUEST["o"]){
				$order = $_REQUEST["o"];
			}
			else{
				$order = "publish_time";
			}

			if ($order == "publish_time"){
				$order_query = $order . " DESC ";
			}
			else{
				$order_query = $order . " ASC ";
			};

			$smarty->assign('order', $order);

			#content of parent directory
			include("_php/search.php");
		}
		#focus page
		else if ($doc_id > 0){
				if ($_GET["f_id"]){
					$parent_dir = $SITE_ROOT . $ext_name_enc . '/' . $path;
					$parent_dir_path = $path;
					$smarty->assign('parent_dir_path',$parent_dir_path);
				}
				else{
					$this_dir = substr($SITE_ROOT . $ext_name_enc . '/' . $path, 0, strlen($SITE_ROOT . $ext_name_enc . '/' . $path)-1);
					$parent_dir = substr($this_dir, 0, strrpos($this_dir, '/')) . '/';
					$this_path = substr($path, 0, strlen($path)-1);
					$parent_dir_path = substr($this_path, 0, strrpos($this_path, '/'));
					if($parent_dir_path != "")
					{
						$smarty->assign('parent_dir_path',$parent_dir_path.'/');
					}
					else
					{
						$smarty->assign('parent_dir_path',$parent_dir_path);
					}
				}
	
				#last in navigation_path is the selected directory
				$smarty->assign('selected_dir', $last);
				$smarty->assign('parent_dir', $parent_dir);
				
				
				$smarty->display('focus_header.tpl');	
	
				#add file or link
				include("_php/add_document.php");
	
				#add directory - with ajax		
				$smarty->display('dir_add_right.tpl');
	
				#content of parent directory
				include("focus.php");			
		}
		#first page
		else if ($parent_id == 0){
			#how many last files should be displayed
			if ($_REQUEST["nr_last"] != ''){
				$nr_last = $_REQUEST["nr_last"];
			}
			else{
				$nr_last = "10";
			};
			$smarty->assign('nr_last', $nr_last);
			
			#add file or link
			include("_php/add_document.php");	

			#last added files
			include("_php/newness.php");
		}
		#directory content
		else{
			$this_dir = substr($SITE_ROOT . $ext_name_enc . '/' . $path, 0, strlen($SITE_ROOT . $ext_name_enc . '/' . $path)-1);
			$parent_dir = substr($this_dir, 0, strrpos($this_dir, '/')+1);
			
			#last in navigation_path is the selected directory
			$smarty->assign('selected_dir', $last);
			$smarty->assign('parent_dir', $parent_dir);
			$this_path = substr($path, 0, strlen($path)-1);
			$parent_dir_path = substr($this_path, 0, strrpos($this_path, '/'));
			if($parent_dir_path != "")
			{
				$smarty->assign('parent_dir_path',$parent_dir_path.'/');
			}
			else
			{
				$smarty->assign('parent_dir_path',$parent_dir_path);
			}
			#page content
			if ($_REQUEST["o"]){
				$order = $_REQUEST["o"];
			}
			else{
				$order = "publish_time";
			}

			if ($order == "publish_time"){
				$order_query = $order . " DESC ";
			}
			else{
				$order_query = $order . " ASC ";
			};

			$smarty->assign('order', $order);
			
			#add file or link
			include("_php/add_document.php");
			
			#content of parent directory
			include("_php/dir_content.php");
		}

		#left menu directories
		include("_php/left_directories.php");
		

			
		$smarty->display('search.tpl');
	
		include("_php/contacts.php");
	
		$smarty->display('footer.tpl');
	
		#end display templates
		#---------------------
	}
}
?>
